# Doctrine Encrypt Type

The bundle will automatically register the types from **\Drjele\DoctrineEncrypt\Type** as Doctrine types.

It can be used for any string field.

**You may fork and modify it as you wish**.

**Contributions are welcomed**.

## Setup and Install
To install the project:

```shell script 
composer require drjele/doctrine-encrypt
```

NOTE: The symfony cache warmup will fail due to a missing salt parameter, which is required for the project to work. Simply create it into your config/packages folder.

```yaml
# config/packages/doctrine-encrypt.yml
drjele_doctrine_encrypt:
    salt: 1234567890123456789012345678901234 # at least 32 characters/digits
    enabled_types: ~ # all types are active by default
```

## Purpose
Encrypt and decrypt data using Doctrine.

I am trying to solve a few problems that i found with the current offerings:
* Have encrypt and decrypt available if using entities or just selecting fields.
* Easy where (_for the moment the parameters have to be encrypted before setting them_).

## Usage
* The value on the entity will always be unencrypted.
* The purpose for **AES256FixedEncryptor**, **AES256FixedType** pair is to be able to use **WHERE**, as it will always return the same result for the same input.
* **EntityService::getEncryptor()** will return the encryptor used for the field, if you need to encrypt a value to use it as a **WHERE** parameter.
* Inside entity:
```php
class Customer
{
    /**
     * @ORM\Column(type="encryptedAES256")
     */
    private string $name;

    public function getName(): ?string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }
}
```
* To encrypt an unencrypted database:
```shell script 
php bin/console drjele:doctrine:database:encrypt
```
* To decrypt an encrypted database:
```shell script 
php bin/console drjele:doctrine:database:decrypt
```

## Todo
* Easy where, pass the unencrypted params and have them automatically encrypt.
* Configure registered encryptors.
* Have a **isEncrypted($entity, $fieldName): bool** method.

## Inspired by
* https://github.com/GiveMeAllYourCats/DoctrineEncryptBundle
* https://github.com/jackprice/doctrine-encrypt
